org.apache.xml.dtm.ref

## Class DTMDefaultBase

- java.lang.Object
- - org.apache.xml.dtm.ref.DTMDefaultBase

- All Implemented Interfaces:
    DTM
  Direct Known Subclasses:
    DTMDefaultBaseTraversers

      public abstract class DTMDefaultBase
      extends java.lang.Object
      implements DTM

  The `DTMDefaultBase` class serves as a helper base for DTMs. It sets up structures for navigation and type, while leaving data management and construction to the derived classes.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_BLOCKSIZE` The default block size of the node arrays
    `static int` | `DEFAULT_NUMBLOCKS` The number of blocks for the node arrays
    `static int` | `DEFAULT_NUMBLOCKS_SMALL` The number of blocks used for small documents & RTFs
    `DTMManager` | `m_mgr` The DTM manager who "owns" this DTM.
    `static int` | `ROOTNODE` The identity of the root node.

    - ### Fields inherited from interface org.apache.xml.dtm.DTM

      `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NAMESPACE_NODE, NOTATION_NODE, NTYPES, NULL, PROCESSING_INSTRUCTION_NODE, ROOT_NODE, TEXT_NODE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DTMDefaultBase(DTMManager mgr, javax.xml.transform.Source source, int dtmIdentity, DTMWSFilter whiteSpaceFilter, XMLStringFactory xstringfactory, boolean doIndexing)` Construct a DTMDefaultBase object using the default block size.
    `DTMDefaultBase(DTMManager mgr, javax.xml.transform.Source source, int dtmIdentity, DTMWSFilter whiteSpaceFilter, XMLStringFactory xstringfactory, boolean doIndexing, int blocksize, boolean usePrevsib, boolean newNameTable)` Construct a DTMDefaultBase object from a DOM node.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `appendChild(int newChild, boolean clone, boolean cloneDepth)` Append a child to the end of the document.
    `void` | `appendTextChild(java.lang.String str)` Append a text node child that will be constructed from a string, to the end of the document.
    `abstract void` | `dispatchCharactersEvents(int nodeHandle, org.xml.sax.ContentHandler ch, boolean normalize)` Directly call the characters method on the passed ContentHandler for the string-value of the given node (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value).
    `abstract void` | `dispatchToEvents(int nodeHandle, org.xml.sax.ContentHandler ch)` Directly create SAX parser events from a subtree.
    `void` | `documentRegistration()` A dummy routine to satisify the abstract interface.
    `void` | `documentRelease()` A dummy routine to satisify the abstract interface.
    `void` | `dumpDTM(java.io.OutputStream os)` Diagnostics function to dump the DTM.
    `java.lang.String` | `dumpNode(int nodeHandle)` Diagnostics function to dump a single node.
    `abstract int` | `getAttributeNode(int nodeHandle, java.lang.String namespaceURI, java.lang.String name)` Retrieves an attribute node by by qualified name and namespace URI.
    `int` | `getDocument()` Find the Document node handle for the document currently under construction.
    `boolean` | `getDocumentAllDeclarationsProcessed()` Return an indication of whether the processor has read the complete DTD.
    `java.lang.String` | `getDocumentBaseURI()` Return the base URI of the document entity.
    `java.lang.String` | `getDocumentEncoding(int nodeHandle)` Return the name of the character encoding scheme in which the document entity is expressed.
    `int` | `getDocumentRoot(int nodeHandle)` Given a node handle, find the owning document node.
    `java.lang.String` | `getDocumentStandalone(int nodeHandle)` Return an indication of the standalone status of the document, either "yes" or "no".
    `java.lang.String` | `getDocumentSystemIdentifier(int nodeHandle)` Return the system identifier of the document entity.
    `abstract java.lang.String` | `getDocumentTypeDeclarationPublicIdentifier()` Return the public identifier of the external subset, normalized as described in 4.2.2 External Entities [XML].
    `abstract java.lang.String` | `getDocumentTypeDeclarationSystemIdentifier()` A document type declaration information item has the following properties: 1.
    `java.lang.String` | `getDocumentVersion(int documentHandle)` Return a string representing the XML version of the document.
    `SuballocatedIntVector` | `getDTMIDs()` Query which DTMIDs this DTM is currently using within the DTMManager.
    `abstract int` | `getElementById(java.lang.String elementId)` Returns the `Element` whose `ID` is given by `elementId`.
    `int` | `getExpandedTypeID(int nodeHandle)` Given a node handle, return an ID that represents the node's expanded name.
    `int` | `getExpandedTypeID(java.lang.String namespace, java.lang.String localName, int type)` Given an expanded name, return an ID.
    `int` | `getFirstAttribute(int nodeHandle)` Given a node handle, get the index of the node's first attribute.
    `int` | `getFirstChild(int nodeHandle)` Given a node handle, get the handle of the node's first child.
    `int` | `getFirstNamespaceNode(int nodeHandle, boolean inScope)` Given a node handle, get the index of the node's first child.
    `int` | `getLastChild(int nodeHandle)` Given a node handle, advance to its last child.
    `short` | `getLevel(int nodeHandle)` Get the depth level of this node in the tree (equals 1 for a parentless node).
    `abstract java.lang.String` | `getLocalName(int nodeHandle)` Given a node handle, return its XPath-style localname.
    `java.lang.String` | `getLocalNameFromExpandedNameID(int expandedNameID)` Given an expanded-name ID, return the local name part.
    `DTMManager` | `getManager()` Query which DTMManager this DTM is currently being handled by.
    `java.lang.String` | `getNamespaceFromExpandedNameID(int expandedNameID)` Given an expanded-name ID, return the namespace URI part.
    `int` | `getNamespaceType(int nodeHandle)` Returns the namespace type of a specific node
    `abstract java.lang.String` | `getNamespaceURI(int nodeHandle)` Given a node handle, return its DOM-style namespace URI (As defined in Namespaces, this is the declared URI which this node's prefix -- or default in lieu thereof -- was mapped to.)
    `int` | `getNextAttribute(int nodeHandle)` Given a node handle, advance to the next attribute.
    `int` | `getNextNamespaceNode(int baseHandle, int nodeHandle, boolean inScope)` Given a namespace handle, advance to the next namespace.
    `int` | `getNextSibling(int nodeHandle)` Given a node handle, advance to its next sibling.
    `org.w3c.dom.Node` | `getNode(int nodeHandle)` Return an DOM node for the given node.
    `int` | `getNodeHandle(int nodeId)` Get the handle of this node in the tree
    `int` | `getNodeIdent(int nodeHandle)` Get the identity of this node in the tree
    `abstract java.lang.String` | `getNodeName(int nodeHandle)` Given a node handle, return its DOM-style node name.
    `java.lang.String` | `getNodeNameX(int nodeHandle)` Given a node handle, return the XPath node name.
    `short` | `getNodeType(int nodeHandle)` Given a node handle, return its DOM-style node type.
    `abstract java.lang.String` | `getNodeValue(int nodeHandle)` Given a node handle, return its node value.
    `int` | `getOwnerDocument(int nodeHandle)` Given a node handle, find the owning document node.
    `int` | `getParent(int nodeHandle)` Given a node handle, find its parent node.
    `abstract java.lang.String` | `getPrefix(int nodeHandle)` Given a namespace handle, return the prefix that the namespace decl is mapping.
    `int` | `getPreviousSibling(int nodeHandle)` Given a node handle, find its preceeding sibling.
    `abstract XMLString` | `getStringValue(int nodeHandle)` Get the string-value of a node as a String object (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value).
    `char[]` | `getStringValueChunk(int nodeHandle, int chunkIndex, int[] startAndLen)` Get a character array chunk in the string-value of a node.
    `int` | `getStringValueChunkCount(int nodeHandle)` Get number of character array chunks in the string-value of a node.
    `int` | `getTypedFirstChild(int nodeHandle, int nodeType)` Given a node handle, get the handle of the node's first child.
    `int` | `getTypedNextSibling(int nodeHandle, int nodeType)` Given a node handle, advance to its next sibling.
    `abstract java.lang.String` | `getUnparsedEntityURI(java.lang.String name)` The getUnparsedEntityURI function returns the URI of the unparsed entity with the specified name in the same document as the context node (see [3.3 Unparsed Entities]).
    `boolean` | `hasChildNodes(int nodeHandle)` Given a node handle, test if it has child nodes.
    `abstract boolean` | `isAttributeSpecified(int attributeHandle)` 5.
    `boolean` | `isCharacterElementContentWhitespace(int nodeHandle)` 2.
    `boolean` | `isDocumentAllDeclarationsProcessed(int documentHandle)` 10.
    `boolean` | `isNodeAfter(int nodeHandle1, int nodeHandle2)` Figure out whether nodeHandle2 should be considered as being later in the document than nodeHandle1, in Document Order as defined by the XPath model.
    `boolean` | `isSupported(java.lang.String feature, java.lang.String version)` Tests whether DTM DOM implementation implements a specific feature and that feature is supported by this node.
    `int` | `makeNodeHandle(int nodeIdentity)` Given a node identity, return a node handle.
    `int` | `makeNodeIdentity(int nodeHandle)` Given a node handle, return a node identity.
    `void` | `migrateTo(DTMManager mgr)` Migrate a DTM built with an old DTMManager to a new DTMManager.
    `void` | `setDocumentBaseURI(java.lang.String baseURI)` Set the base URI of the document entity.
    `void` | `setFeature(java.lang.String featureId, boolean state)` Set an implementation dependent feature.
    `boolean` | `supportsPreStripping()` Return true if the xsl:strip-space or xsl:preserve-space was processed during construction of the DTM document.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.xml.dtm.DTM

      `getAxisIterator, getAxisTraverser, getContentHandler, getDeclHandler, getDTDHandler, getEntityResolver, getErrorHandler, getLexicalHandler, getSourceLocatorFor, getTypedAxisIterator, needsTwoThreads, setProperty`

- - ### Field Detail

    - #### ROOTNODE

          public static final int ROOTNODE

      The identity of the root node.
      See Also:
        Constant Field Values

    - #### DEFAULT_BLOCKSIZE

          public static final int DEFAULT_BLOCKSIZE

      The default block size of the node arrays
      See Also:
        Constant Field Values

    - #### DEFAULT_NUMBLOCKS

          public static final int DEFAULT_NUMBLOCKS

      The number of blocks for the node arrays
      See Also:
        Constant Field Values

    - #### DEFAULT_NUMBLOCKS_SMALL

          public static final int DEFAULT_NUMBLOCKS_SMALL

      The number of blocks used for small documents & RTFs
      See Also:
        Constant Field Values

    - #### m_mgr

          public DTMManager m_mgr

      The DTM manager who "owns" this DTM.

  - ### Constructor Detail

    - #### DTMDefaultBase

          public DTMDefaultBase(DTMManager mgr,
                                javax.xml.transform.Source source,
                                int dtmIdentity,
                                DTMWSFilter whiteSpaceFilter,
                                XMLStringFactory xstringfactory,
                                boolean doIndexing)

      Construct a DTMDefaultBase object using the default block size.
      Parameters:
        `mgr` - The DTMManager who owns this DTM.
        `source` - The object that is used to specify the construction source.
        `dtmIdentity` - The DTM identity ID for this DTM.
        `whiteSpaceFilter` - The white space filter for this DTM, which may be null.
        `xstringfactory` - The factory to use for creating XMLStrings.
        `doIndexing` - true if the caller considers it worth it to use indexing schemes.

    - #### DTMDefaultBase

          public DTMDefaultBase(DTMManager mgr,
                                javax.xml.transform.Source source,
                                int dtmIdentity,
                                DTMWSFilter whiteSpaceFilter,
                                XMLStringFactory xstringfactory,
                                boolean doIndexing,
                                int blocksize,
                                boolean usePrevsib,
                                boolean newNameTable)

      Construct a DTMDefaultBase object from a DOM node.
      Parameters:
        `mgr` - The DTMManager who owns this DTM.
        `source` - The object that is used to specify the construction source.
        `dtmIdentity` - The DTM identity ID for this DTM.
        `whiteSpaceFilter` - The white space filter for this DTM, which may be null.
        `xstringfactory` - The factory to use for creating XMLStrings.
        `doIndexing` - true if the caller considers it worth it to use indexing schemes.
        `blocksize` - The block size of the DTM.
        `usePrevsib` - true if we want to build the previous sibling node array.
        `newNameTable` - true if we want to use a new ExpandedNameTable for this DTM.

  - ### Method Detail

    - #### dumpDTM

          public void dumpDTM(java.io.OutputStream os)

      Diagnostics function to dump the DTM.

    - #### dumpNode

          public java.lang.String dumpNode(int nodeHandle)

      Diagnostics function to dump a single node. %REVIEW% KNOWN GLITCH: If you pass it a node index rather than a node handle, it works just fine... but the displayed identity number before the colon is different, which complicates comparing it with nodes printed the other way. We could always OR the DTM ID into the value, to suppress that distinction... %REVIEW% This might want to be moved up to DTMDefaultBase, or possibly DTM itself, since it's a useful diagnostic and uses only DTM's public APIs.

    - #### setFeature

          public void setFeature(java.lang.String featureId,
                                 boolean state)

      Set an implementation dependent feature.

      %REVIEW% Do we really expect to set features on DTMs?

      Specified by:
        `setFeature` in interface `DTM`
      Parameters:
        `featureId` - A feature URL.
        `state` - true if this feature should be on, false otherwise.

    - #### hasChildNodes

          public boolean hasChildNodes(int nodeHandle)

      Given a node handle, test if it has child nodes.

      %REVIEW% This is obviously useful at the DOM layer, where it would permit testing this without having to create a proxy node. It's less useful in the DTM API, where (dtm.getFirstChild(nodeHandle)!=DTM.NULL) is just as fast and almost as self-evident. But it's a convenience, and eases porting of DOM code to DTM.

      Specified by:
        `hasChildNodes` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int true if the given node has child nodes.

    - #### makeNodeHandle

          public final int makeNodeHandle(int nodeIdentity)

      Given a node identity, return a node handle. If extended addressing has been used (multiple DTM IDs), we need to map the high bits of the identity into the proper DTM ID. This has been made FINAL to facilitate inlining, since we do not expect any subclass of DTMDefaultBase to ever change the algorithm. (I don't really like doing so, and would love to have an excuse not to...) %REVIEW% Is it worth trying to specialcase small documents? %REVIEW% Should this be exposed at the package/public layers?
      Parameters:
        `nodeIdentity` - Internal offset to this node's records.
      Returns:
        NodeHandle (external representation of node)

    - #### makeNodeIdentity

          public final int makeNodeIdentity(int nodeHandle)

      Given a node handle, return a node identity. If extended addressing has been used (multiple DTM IDs), we need to map the high bits of the identity into the proper DTM ID and thence find the proper offset to add to the low bits of the identity This has been made FINAL to facilitate inlining, since we do not expect any subclass of DTMDefaultBase to ever change the algorithm. (I don't really like doing so, and would love to have an excuse not to...) %OPT% Performance is critical for this operation. %REVIEW% Should this be exposed at the package/public layers?
      Parameters:
        `nodeHandle` - (external representation of node)
      Returns:
        nodeIdentity Internal offset to this node's records.

    - #### getFirstChild

          public int getFirstChild(int nodeHandle)

      Given a node handle, get the handle of the node's first child. If not yet resolved, waits for more nodes to be added to the document and tries again.
      Specified by:
        `getFirstChild` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int DTM node-number of first child, or DTM.NULL to indicate none exists.

    - #### getTypedFirstChild

          public int getTypedFirstChild(int nodeHandle,
                                        int nodeType)

      Given a node handle, get the handle of the node's first child. If not yet resolved, waits for more nodes to be added to the document and tries again.
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int DTM node-number of first child, or DTM.NULL to indicate none exists.

    - #### getLastChild

          public int getLastChild(int nodeHandle)

      Given a node handle, advance to its last child. If not yet resolved, waits for more nodes to be added to the document and tries again.
      Specified by:
        `getLastChild` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int Node-number of last child, or DTM.NULL to indicate none exists.

    - #### getAttributeNode

          public abstract int getAttributeNode(int nodeHandle,
                                               java.lang.String namespaceURI,
                                               java.lang.String name)

      Retrieves an attribute node by by qualified name and namespace URI.
      Specified by:
        `getAttributeNode` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node upon which to look up this attribute..
        `namespaceURI` - The namespace URI of the attribute to retrieve, or null.
        `name` - The local name of the attribute to retrieve.
      Returns:
        The attribute node handle with the specified name ( `nodeName`) or `DTM.NULL` if there is no such attribute.

    - #### getFirstAttribute

          public int getFirstAttribute(int nodeHandle)

      Given a node handle, get the index of the node's first attribute.
      Specified by:
        `getFirstAttribute` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        Handle of first attribute, or DTM.NULL to indicate none exists.

    - #### getNextSibling

          public int getNextSibling(int nodeHandle)

      Given a node handle, advance to its next sibling. If not yet resolved, waits for more nodes to be added to the document and tries again.
      Specified by:
        `getNextSibling` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int Node-number of next sibling, or DTM.NULL to indicate none exists.

    - #### getTypedNextSibling

          public int getTypedNextSibling(int nodeHandle,
                                         int nodeType)

      Given a node handle, advance to its next sibling. If not yet resolved, waits for more nodes to be added to the document and tries again.
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int Node-number of next sibling, or DTM.NULL to indicate none exists.

    - #### getPreviousSibling

          public int getPreviousSibling(int nodeHandle)

      Given a node handle, find its preceeding sibling. WARNING: DTM is asymmetric; this operation is resolved by search, and is relatively expensive.
      Specified by:
        `getPreviousSibling` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        int Node-number of the previous sib, or DTM.NULL to indicate none exists.

    - #### getNextAttribute

          public int getNextAttribute(int nodeHandle)

      Given a node handle, advance to the next attribute. If an attr, we advance to the next attr on the same node. If not an attribute, we return NULL.
      Specified by:
        `getNextAttribute` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int DTM node-number of the resolved attr, or DTM.NULL to indicate none exists.

    - #### getFirstNamespaceNode

          public int getFirstNamespaceNode(int nodeHandle,
                                           boolean inScope)

      Given a node handle, get the index of the node's first child. If not yet resolved, waits for more nodes to be added to the document and tries again
      Specified by:
        `getFirstNamespaceNode` in interface `DTM`
      Parameters:
        `nodeHandle` - handle to node, which should probably be an element node, but need not be.
        `inScope` - true if all namespaces in scope should be returned, false if only the namespace declarations should be returned.
      Returns:
        handle of first namespace, or DTM.NULL to indicate none exists.

    - #### getNextNamespaceNode

          public int getNextNamespaceNode(int baseHandle,
                                          int nodeHandle,
                                          boolean inScope)

      Given a namespace handle, advance to the next namespace.
      Specified by:
        `getNextNamespaceNode` in interface `DTM`
      Parameters:
        `baseHandle` - handle to original node from where the first namespace was relative to (needed to return nodes in document order).
        `nodeHandle` - A namespace handle for which we will find the next node.
        `inScope` - true if all namespaces that are in scope should be processed, otherwise just process the nodes in the given element handle.
      Returns:
        handle of next namespace, or DTM.NULL to indicate none exists.

    - #### getParent

          public int getParent(int nodeHandle)

      Given a node handle, find its parent node.
      Specified by:
        `getParent` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        int Node-number of parent, or DTM.NULL to indicate none exists.

    - #### getDocument

          public int getDocument()

      Find the Document node handle for the document currently under construction. PLEASE NOTE that most people should use getOwnerDocument(nodeHandle) instead; this version of the operation is primarily intended for use during negotiation with the DTM Manager.
      Specified by:
        `getDocument` in interface `DTM`
      Returns:
        int Node handle of document, which should always be valid.

    - #### getOwnerDocument

          public int getOwnerDocument(int nodeHandle)

      Given a node handle, find the owning document node. This has the exact same semantics as the DOM Document method of the same name, in that if the nodeHandle is a document node, it will return NULL.

      %REVIEW% Since this is DOM-specific, it may belong at the DOM binding layer. Included here as a convenience function and to aid porting of DOM code to DTM.

      Specified by:
        `getOwnerDocument` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        int Node handle of owning document, or -1 if the node was a Docment
      See Also:
        `DTM.getDocumentRoot(int nodeHandle)`

    - #### getDocumentRoot

          public int getDocumentRoot(int nodeHandle)

      Given a node handle, find the owning document node. Unlike the DOM, this considers the owningDocument of a Document to be itself.
      Specified by:
        `getDocumentRoot` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        int Node handle of owning document, or the nodeHandle if it is a Document.
      See Also:
        `DTM.getOwnerDocument(int nodeHandle)`

    - #### getStringValue

          public abstract XMLString getStringValue(int nodeHandle)

      Get the string-value of a node as a String object (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value).
      Specified by:
        `getStringValue` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
      Returns:
        A string object that represents the string-value of the given node.

    - #### getStringValueChunkCount

          public int getStringValueChunkCount(int nodeHandle)

      Get number of character array chunks in the string-value of a node. (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value). Note that a single text node may have multiple text chunks.
      Specified by:
        `getStringValueChunkCount` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
      Returns:
        number of character array chunks in the string-value of a node.

    - #### getStringValueChunk

          public char[] getStringValueChunk(int nodeHandle,
                                            int chunkIndex,
                                            int[] startAndLen)

      Get a character array chunk in the string-value of a node. (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value). Note that a single text node may have multiple text chunks.
      Specified by:
        `getStringValueChunk` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
        `chunkIndex` - Which chunk to get.
        `startAndLen` - An array of 2 where the start position and length of the chunk will be returned.
      Returns:
        The character array reference where the chunk occurs.

    - #### getExpandedTypeID

          public int getExpandedTypeID(int nodeHandle)

      Given a node handle, return an ID that represents the node's expanded name.
      Specified by:
        `getExpandedTypeID` in interface `DTM`
      Parameters:
        `nodeHandle` - The handle to the node in question.
      Returns:
        the expanded-name id of the node.

    - #### getExpandedTypeID

          public int getExpandedTypeID(java.lang.String namespace,
                                       java.lang.String localName,
                                       int type)

      Given an expanded name, return an ID. If the expanded-name does not exist in the internal tables, the entry will be created, and the ID will be returned. Any additional nodes that are created that have this expanded name will use this ID.
      Specified by:
        `getExpandedTypeID` in interface `DTM`
      Parameters:
        `type` - The simple type, i.e. one of ELEMENT, ATTRIBUTE, etc.
        `namespace` - The namespace URI, which may be null, may be an empty string (which will be the same as null), or may be a namespace URI.
        `localName` - The local name string, which must be a valid NCName.
      Returns:
        the expanded-name id of the node.

    - #### getLocalNameFromExpandedNameID

          public java.lang.String getLocalNameFromExpandedNameID(int expandedNameID)

      Given an expanded-name ID, return the local name part.
      Specified by:
        `getLocalNameFromExpandedNameID` in interface `DTM`
      Parameters:
        `expandedNameID` - an ID that represents an expanded-name.
      Returns:
        String Local name of this node.

    - #### getNamespaceFromExpandedNameID

          public java.lang.String getNamespaceFromExpandedNameID(int expandedNameID)

      Given an expanded-name ID, return the namespace URI part.
      Specified by:
        `getNamespaceFromExpandedNameID` in interface `DTM`
      Parameters:
        `expandedNameID` - an ID that represents an expanded-name.
      Returns:
        String URI value of this node's namespace, or null if no namespace was resolved.

    - #### getNamespaceType

          public int getNamespaceType(int nodeHandle)

      Returns the namespace type of a specific node
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        the ID of the namespace.

    - #### getNodeName

          public abstract java.lang.String getNodeName(int nodeHandle)

      Given a node handle, return its DOM-style node name. This will include names such as #text or #document.
      Specified by:
        `getNodeName` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String Name of this node, which may be an empty string. %REVIEW% Document when empty string is possible... %REVIEW-COMMENT% It should never be empty, should it?

    - #### getNodeNameX

          public java.lang.String getNodeNameX(int nodeHandle)

      Given a node handle, return the XPath node name. This should be the name as described by the XPath data model, NOT the DOM-style name.
      Specified by:
        `getNodeNameX` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String Name of this node, which may be an empty string.

    - #### getLocalName

          public abstract java.lang.String getLocalName(int nodeHandle)

      Given a node handle, return its XPath-style localname. (As defined in Namespaces, this is the portion of the name after any colon character).
      Specified by:
        `getLocalName` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String Local name of this node.

    - #### getPrefix

          public abstract java.lang.String getPrefix(int nodeHandle)

      Given a namespace handle, return the prefix that the namespace decl is mapping. Given a node handle, return the prefix used to map to the namespace.

      %REVIEW% Are you sure you want "" for no prefix?

      %REVIEW-COMMENT% I think so... not totally sure. -sb

      Specified by:
        `getPrefix` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String prefix of this node's name, or "" if no explicit namespace prefix was given.

    - #### getNamespaceURI

          public abstract java.lang.String getNamespaceURI(int nodeHandle)

      Given a node handle, return its DOM-style namespace URI (As defined in Namespaces, this is the declared URI which this node's prefix -- or default in lieu thereof -- was mapped to.)

      %REVIEW% Null or ""? -sb

      Specified by:
        `getNamespaceURI` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String URI value of this node's namespace, or null if no namespace was resolved.

    - #### getNodeValue

          public abstract java.lang.String getNodeValue(int nodeHandle)

      Given a node handle, return its node value. This is mostly as defined by the DOM, but may ignore some conveniences.

      Specified by:
        `getNodeValue` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id.
      Returns:
        String Value of this node, or null if not meaningful for this node type.

    - #### getNodeType

          public short getNodeType(int nodeHandle)

      Given a node handle, return its DOM-style node type.

      %REVIEW% Generally, returning short is false economy. Return int? %REVIEW% Make assumption that node has already arrived. Is OK?

      Specified by:
        `getNodeType` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id.
      Returns:
        int Node type, as per the DOM's Node._NODE constants.

    - #### getLevel

          public short getLevel(int nodeHandle)

      Get the depth level of this node in the tree (equals 1 for a parentless node).
      Specified by:
        `getLevel` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id.
      Returns:
        the number of ancestors, plus one
      Usage:
        **For internal use only**

    - #### getNodeIdent

          public int getNodeIdent(int nodeHandle)

      Get the identity of this node in the tree
      Parameters:
        `nodeHandle` - The node handle.
      Returns:
        the node identity
      Usage:
        **For internal use only**

    - #### getNodeHandle

          public int getNodeHandle(int nodeId)

      Get the handle of this node in the tree
      Parameters:
        `nodeId` - The node identity.
      Returns:
        the node handle
      Usage:
        **For internal use only**

    - #### isSupported

          public boolean isSupported(java.lang.String feature,
                                     java.lang.String version)

      Tests whether DTM DOM implementation implements a specific feature and that feature is supported by this node.
      Specified by:
        `isSupported` in interface `DTM`
      Parameters:
        `feature` - The name of the feature to test.
        `version` - This is the version number of the feature to test. If the version is not specified, supporting any version of the feature will cause the method to return `true`.
      Returns:
        Returns `true` if the specified feature is supported on this node, `false` otherwise.

    - #### getDocumentBaseURI

          public java.lang.String getDocumentBaseURI()

      Return the base URI of the document entity. If it is not known (because the document was parsed from a socket connection or from standard input, for example), the value of this property is unknown.
      Specified by:
        `getDocumentBaseURI` in interface `DTM`
      Returns:
        the document base URI String object or null if unknown.

    - #### setDocumentBaseURI

          public void setDocumentBaseURI(java.lang.String baseURI)

      Set the base URI of the document entity.
      Specified by:
        `setDocumentBaseURI` in interface `DTM`
      Parameters:
        `baseURI` - the document base URI String object or null if unknown.

    - #### getDocumentSystemIdentifier

          public java.lang.String getDocumentSystemIdentifier(int nodeHandle)

      Return the system identifier of the document entity. If it is not known, the value of this property is unknown.
      Specified by:
        `getDocumentSystemIdentifier` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id, which can be any valid node handle.
      Returns:
        the system identifier String object or null if unknown.

    - #### getDocumentEncoding

          public java.lang.String getDocumentEncoding(int nodeHandle)

      Return the name of the character encoding scheme in which the document entity is expressed.
      Specified by:
        `getDocumentEncoding` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id, which can be any valid node handle.
      Returns:
        the document encoding String object.
      Usage:
        **For internal use only**

    - #### getDocumentStandalone

          public java.lang.String getDocumentStandalone(int nodeHandle)

      Return an indication of the standalone status of the document, either "yes" or "no". This property is derived from the optional standalone document declaration in the XML declaration at the beginning of the document entity, and has no value if there is no standalone document declaration.
      Specified by:
        `getDocumentStandalone` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id, which can be any valid node handle.
      Returns:
        the document standalone String object, either "yes", "no", or null.

    - #### getDocumentVersion

          public java.lang.String getDocumentVersion(int documentHandle)

      Return a string representing the XML version of the document. This property is derived from the XML declaration optionally present at the beginning of the document entity, and has no value if there is no XML declaration.
      Specified by:
        `getDocumentVersion` in interface `DTM`
      Parameters:
        `documentHandle` - The document handle
      Returns:
        the document version String object.

    - #### getDocumentAllDeclarationsProcessed

          public boolean getDocumentAllDeclarationsProcessed()

      Return an indication of whether the processor has read the complete DTD. Its value is a boolean. If it is false, then certain properties (indicated in their descriptions below) may be unknown. If it is true, those properties are never unknown.
      Specified by:
        `getDocumentAllDeclarationsProcessed` in interface `DTM`
      Returns:
        `true` if all declarations were processed; `false` otherwise.

    - #### getDocumentTypeDeclarationSystemIdentifier

          public abstract java.lang.String getDocumentTypeDeclarationSystemIdentifier()

      A document type declaration information item has the following properties: 1. [system identifier] The system identifier of the external subset, if it exists. Otherwise this property has no value.
      Specified by:
        `getDocumentTypeDeclarationSystemIdentifier` in interface `DTM`
      Returns:
        the system identifier String object, or null if there is none.

    - #### getDocumentTypeDeclarationPublicIdentifier

          public abstract java.lang.String getDocumentTypeDeclarationPublicIdentifier()

      Return the public identifier of the external subset, normalized as described in 4.2.2 External Entities [XML]. If there is no external subset or if it has no public identifier, this property has no value.
      Specified by:
        `getDocumentTypeDeclarationPublicIdentifier` in interface `DTM`
      Returns:
        the public identifier String object, or null if there is none.

    - #### getElementById

          public abstract int getElementById(java.lang.String elementId)

      Returns the `Element` whose `ID` is given by `elementId`. If no such element exists, returns `DTM.NULL`. Behavior is not defined if more than one element has this `ID`. Attributes (including those with the name "ID") are not of type ID unless so defined by DTD/Schema information available to the DTM implementation. Implementations that do not know whether attributes are of type ID or not are expected to return `DTM.NULL`.

      %REVIEW% Presumably IDs are still scoped to a single document, and this operation searches only within a single document, right? Wouldn't want collisions between DTMs in the same process.

      Specified by:
        `getElementById` in interface `DTM`
      Parameters:
        `elementId` - The unique `id` value for an element.
      Returns:
        The handle of the matching element.

    - #### getUnparsedEntityURI

          public abstract java.lang.String getUnparsedEntityURI(java.lang.String name)

      The getUnparsedEntityURI function returns the URI of the unparsed entity with the specified name in the same document as the context node (see [3.3 Unparsed Entities]). It returns the empty string if there is no such entity.

      XML processors may choose to use the System Identifier (if one is provided) to resolve the entity, rather than the URI in the Public Identifier. The details are dependent on the processor, and we would have to support some form of plug-in resolver to handle this properly. Currently, we simply return the System Identifier if present, and hope that it a usable URI or that our caller can map it to one. TODO: Resolve Public Identifiers... or consider changing function name.

      If we find a relative URI reference, XML expects it to be resolved in terms of the base URI of the document. The DOM doesn't do that for us, and it isn't entirely clear whether that should be done here; currently that's pushed up to a higher level of our application. (Note that DOM Level 1 didn't store the document's base URI.) TODO: Consider resolving Relative URIs.

      (The DOM's statement that "An XML processor may choose to completely expand entities before the structure model is passed to the DOM" refers only to parsed entities, not unparsed, and hence doesn't affect this function.)

      Specified by:
        `getUnparsedEntityURI` in interface `DTM`
      Parameters:
        `name` - A string containing the Entity Name of the unparsed entity.
      Returns:
        String containing the URI of the Unparsed Entity, or an empty string if no such entity exists.

    - #### supportsPreStripping

          public boolean supportsPreStripping()

      Return true if the xsl:strip-space or xsl:preserve-space was processed during construction of the DTM document.
      Specified by:
        `supportsPreStripping` in interface `DTM`
      Returns:
        true if this DTM supports prestripping.

    - #### isNodeAfter

          public boolean isNodeAfter(int nodeHandle1,
                                     int nodeHandle2)

      Figure out whether nodeHandle2 should be considered as being later in the document than nodeHandle1, in Document Order as defined by the XPath model. This may not agree with the ordering defined by other XML applications.

      There are some cases where ordering isn't defined, and neither are the results of this function -- though we'll generally return false.

      Specified by:
        `isNodeAfter` in interface `DTM`
      Parameters:
        `nodeHandle1` - Node handle to perform position comparison on.
        `nodeHandle2` - Second Node handle to perform position comparison on .
      Returns:
        true if node1 comes before node2, otherwise return false. You can think of this as `(node1.documentOrderPosition <= node2.documentOrderPosition)`.

    - #### isCharacterElementContentWhitespace

          public boolean isCharacterElementContentWhitespace(int nodeHandle)

      2. [element content whitespace] A boolean indicating whether the character is white space appearing within element content (see [XML], 2.10 "White Space Handling"). Note that validating XML processors are required by XML 1.0 to provide this information. If there is no declaration for the containing element, this property has no value for white space characters. If no declaration has been read, but the [all declarations processed] property of the document information item is false (so there may be an unread declaration), then the value of this property is unknown for white space characters. It is always false for characters that are not white space.
      Specified by:
        `isCharacterElementContentWhitespace` in interface `DTM`
      Parameters:
        `nodeHandle` - the node ID.
      Returns:
        `true` if the character data is whitespace; `false` otherwise.

    - #### isDocumentAllDeclarationsProcessed

          public boolean isDocumentAllDeclarationsProcessed(int documentHandle)

      10. [all declarations processed] This property is not strictly speaking part of the infoset of the document. Rather it is an indication of whether the processor has read the complete DTD. Its value is a boolean. If it is false, then certain properties (indicated in their descriptions below) may be unknown. If it is true, those properties are never unknown.
      Specified by:
        `isDocumentAllDeclarationsProcessed` in interface `DTM`
      Parameters:
        `documentHandle` - A node handle that must identify a document.
      Returns:
        `true` if all declarations were processed; `false` otherwise.

    - #### isAttributeSpecified

          public abstract boolean isAttributeSpecified(int attributeHandle)

      5. [specified] A flag indicating whether this attribute was actually specified in the start-tag of its element, or was defaulted from the DTD.
      Specified by:
        `isAttributeSpecified` in interface `DTM`
      Parameters:
        `attributeHandle` - The attribute handle in question.
      Returns:
        `true` if the attribute was specified; `false` if it was defaulted.

    - #### dispatchCharactersEvents

          public abstract void dispatchCharactersEvents(int nodeHandle,
                                                        org.xml.sax.ContentHandler ch,
                                                        boolean normalize)
                                                 throws org.xml.sax.SAXException

      Directly call the characters method on the passed ContentHandler for the string-value of the given node (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value). Multiple calls to the ContentHandler's characters methods may well occur for a single call to this method.
      Specified by:
        `dispatchCharactersEvents` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
        `ch` - A non-null reference to a ContentHandler.
        `normalize` - true if the content should be normalized according to the rules for the XPath normalize-space function.
      Throws:
        `org.xml.sax.SAXException`

    - #### dispatchToEvents

          public abstract void dispatchToEvents(int nodeHandle,
                                                org.xml.sax.ContentHandler ch)
                                         throws org.xml.sax.SAXException

      Directly create SAX parser events from a subtree.
      Specified by:
        `dispatchToEvents` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
        `ch` - A non-null reference to a ContentHandler.
      Throws:
        `org.xml.sax.SAXException`

    - #### getNode

          public org.w3c.dom.Node getNode(int nodeHandle)

      Return an DOM node for the given node.
      Specified by:
        `getNode` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
      Returns:
        A node representation of the DTM node.

    - #### appendChild

          public void appendChild(int newChild,
                                  boolean clone,
                                  boolean cloneDepth)

      Append a child to the end of the document. Please note that the node is always cloned if it is owned by another document.

      %REVIEW% "End of the document" needs to be defined more clearly. Does it become the last child of the Document? Of the root element?

      Specified by:
        `appendChild` in interface `DTM`
      Parameters:
        `newChild` - Must be a valid new node handle.
        `clone` - true if the child should be cloned into the document.
        `cloneDepth` - if the clone argument is true, specifies that the clone should include all it's children.

    - #### appendTextChild

          public void appendTextChild(java.lang.String str)

      Append a text node child that will be constructed from a string, to the end of the document.

      %REVIEW% "End of the document" needs to be defined more clearly. Does it become the last child of the Document? Of the root element?

      Specified by:
        `appendTextChild` in interface `DTM`
      Parameters:
        `str` - Non-null reverence to a string.

    - #### documentRegistration

          public void documentRegistration()

      A dummy routine to satisify the abstract interface. If the DTM implememtation that extends the default base requires notification of registration, they can override this method.
      Specified by:
        `documentRegistration` in interface `DTM`

    - #### documentRelease

          public void documentRelease()

      A dummy routine to satisify the abstract interface. If the DTM implememtation that extends the default base requires notification when the document is being released, they can override this method
      Specified by:
        `documentRelease` in interface `DTM`

    - #### migrateTo

          public void migrateTo(DTMManager mgr)

      Migrate a DTM built with an old DTMManager to a new DTMManager. After the migration, the new DTMManager will treat the DTM as one that is built by itself. This is used to support DTM sharing between multiple transformations.
      Specified by:
        `migrateTo` in interface `DTM`
      Parameters:
        `mgr` - the DTMManager

    - #### getManager

          public DTMManager getManager()

      Query which DTMManager this DTM is currently being handled by. %REVEW% Should this become part of the base DTM API?
      Returns:
        a DTMManager, or null if this is a "stand-alone" DTM.

    - #### getDTMIDs

          public SuballocatedIntVector getDTMIDs()

      Query which DTMIDs this DTM is currently using within the DTMManager. %REVEW% Should this become part of the base DTM API?
      Returns:
        an IntVector, or null if this is a "stand-alone" DTM.

Copyright © 2023 Apache XML Project. All Rights Reserved.